function p = trvconv

% end point
T=2;
%vector of stepsizes
h=0.5.^[4:10];
% initial value
y0=2;

% exact solution of y'(t)=2(y-y^2), y(0)=y0
sol=@(t,y0)  y0./(y0+(1-y0)*exp(-2*t));


% Preallocate storage area
err1 = zeros(1,length(h));
err2 = zeros(1,length(h));
err3 = zeros(1,length(h));


% find method errorVerfahrensfehler ermitteln
for j=1:length(h)    
    % compute the absolute error for the different methods
	err1(j) = abs( trv_1(h(j),T,y0)-sol(T,y0));
	err2(j) = abs( trv_2(h(j),T,y0)-sol(T,y0));
	err3(j) = abs( trv_3(h(j),T,y0)-sol(T,y0));
end

% plot results
figure;
loglog(h, err1, 'bx-', h, err2, 'rx-', h,err3, 'gx-', 'LineWidth', 2); 
title('convergence rate for the Taylor series method for n=1,2,3');
xlabel('h');
ylabel('error');
set(gca, 'XDir', 'reverse');
grid on;
print -depsc trvconv

% compute rate of convergence
fit = polyfit(log(h),log(err1),1);
p(1) = fit(1);
fprintf('experimental convergence rate for n=1: %f\n', p(1));
fit = polyfit(log(h),log(err2),1);
p(2) = fit(1);
fprintf('experimental convergence rate for n=2: %f\n', p(2));
fit = polyfit(log(h),log(err3),1);
p(3) = fit(1);
fprintf('experimental convergence rate for n=3: %f\n', p(3));